<html><head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <title>fspecial</title>
    <style type="text/css" media="all">
      @import url("scilab_code.css");
      @import url("xml_code.css");
      @import url("c_code.css");
      @import url("style.css");
    </style>
  </head>
  <body>
    <div class="manualnavbar">
    <table width="100%"><tr>
      <td width="30%">
    	<span class="previous"><a href="filter2.html">&lt;&lt; filter2</a></span>

      </td>
      <td width="40%" class="center">
      	<span class="top"><a href="section_3ba7058e738fa302f12702588c6eea04.html">Image Linear Filtering</a></span>

      </td>
      <td width="30%" class="next">
      	<span class="next"><a href="imfilter.html">imfilter &gt;&gt;</a></span>

      </td>
    </tr></table>
      <hr />
    </div>



    <span class="path"><a href="index.html">IPCV - Image Processing and Computer Vision Toolbox for Scilab</a> &gt;&gt; <a href="section_3ba7058e738fa302f12702588c6eea04.html">Image Linear Filtering</a> &gt; fspecial</span>

    <br /><br />
    <div class="refnamediv"><h1 class="refname">fspecial</h1>
    <p class="refpurpose">Create some 2D special filters</p></div>


<div class="refsynopsisdiv"><h3 class="title">Syntax</h3>
   <div class="synopsis"><pre><span class="default">F</span><span class="default"> = </span><span class="functionid">fspecial</span><span class="default">(</span><span class="default">type</span><span class="default">)</span>
<span class="default">F</span><span class="default"> = </span><span class="functionid">fspecial</span><span class="default">(</span><span class="default">type</span><span class="default">, </span><span class="default">op1</span><span class="default">)</span>
<span class="default">F</span><span class="default"> = </span><span class="functionid">fspecial</span><span class="default">(</span><span class="default">type</span><span class="default">, </span><span class="default">op1</span><span class="default">, </span><span class="default">op2</span><span class="default">)</span></pre></div></div>

<div class="refsection"><h3 class="title">Parameters</h3>
   <dl><dt><span class="term">type :</span>
      <dd><p class="para">Filter type. It can be one of these string: &#0039;sobel&#0039;, &#0039;prewitt&#0039;, &#0039;gaussion&#0039;, &#0039;laplacian&#0039;, &#0039;log&#0039;, &#0039;average&#0039;, &#0039;unsharp&#0039;, &#0039;motion&#0039;. (&#0039;disk&#0039; in future.)</p></dd></dt>
   <dt><span class="term">op1 :</span>
      <dd><p class="para">The first parameter for the filter. Some type of filters do not need it.</p></dd></dt>
   <dt><span class="term">op2 :</span>
      <dd><p class="para">The second parameter for the filter. Some type of filters do not need it.</p></dd></dt>
   <dt><span class="term">FT :</span>
      <dd><p class="para">The returned filter, which is of type double.</p></dd></dt></dl></div>

<div class="refsection"><h3 class="title">Description</h3>
   <p class="para">fspecial create some 2D special filters. If no parameters are given, fspecial will uses default values.</p>
   <p class="para">The supported filters and the syntax for each filter type are listed in the following list:</p>
   <p class="para"><dl><dt><span class="term">F = fspecial(&#0039;sobel&#0039;) :</span>
<dd>returns a 3x3 horizontal edges sobel filter. If you want avertical e dges sobel filter, you can use transposition of F. F is [ 1 2 1; 0 0 0; -1 -2 -1].</dd></dt>
<dt><span class="term">F = fspecial(&#0039;prewitt&#0039;) :</span>
<dd>returns a 3x3 horizontal edges prewitt filter. If you want avertical edges prewitt filter, you can use transposition of F. F is [ 1 1 1; 0 0 0; -1 -1 -1].</dd></dt>
<dt><span class="term">F = fspecial(&#0039;gaussian&#0039;, hsize, sigma) :</span>
<dd>returns a Gaussian lowpass filter. The size of returned filter is determined by parameter hsize. hsize can be a 1x2 vector which indicate the rows and columns of F. If hsize is a scalar, F is a square matrix. The default value for hsize is [3, 3]; the default value for sigma is 0.5.</dd></dt>
<dt><span class="term">F = fspecial(&#0039;laplacian&#0039;, alpha) :</span>
<dd>returns a 3-by-3 Laplacian filter. The returned filter is [alpha, 1-alpha, alpha; 1-alpha, -4, 1-alpha; alpha, 1-alpha, alpha]/(alpha+1). The default value for alpha is 0.2.</dd></dt>
<dt><span class="term">F = fspecial(&#0039;log&#0039;, hsize, sigma) :</span>
<dd>returns a Laplacian of Gaussian filter. The size of returned filter is determined by parameter hsize. hsize can be a 1x2 vector which indicate the rows and columns of F. If hsize is a scalar, F is a square matrix. The default value for hsize is [5, 5]; the default value for sigma is 0.5.</dd></dt>
<dt><span class="term">F = fspecial(&#0039;average&#0039;,hsize) :</span>
<dd>returns an averaging filter. The size of returned filter is determined by parameter hsize. hsize can be a 1x2 vector which indicate the rows and columns of F. If hsize is a scalar, F is a square matrix. The default value for hsize is [3, 3].</dd></dt>
<dt><span class="term">F = fspecial(&#0039;unsharp&#0039;, alpha) :</span>
<dd>returns a 3x3 unsharp contrast enhancement filter. alpha must be in the range [0.0, 1.0]. The default value of alpha is 0.2.</dd></dt>
<dt><span class="term">F = fspecial(&#0039;motion&#0039;, length, angle1) :</span>
<dd>returns a motion blurred filter with length and angle.</dd></dt></dl></p>
   <p class="para"></p></div>

<div class="refsection"><h3 class="title">Examples</h3>
   <div class="programlisting"><table border="0" width="100%"><tr><td width="98%"><pre class="scilabcode"><span class="scilabid">im</span> <span class="scilaboperator">=</span> <span class="scilabid">imread</span><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://fullpath">fullpath</a><span class="scilabopenclose">(</span><span class="scilabid">getIPCVpath</span><span class="scilabopenclose">(</span><span class="scilabopenclose">)</span> <span class="scilaboperator">+</span> <span class="scilabstring">&#0034;</span><span class="scilabstring">/images/baboon.png</span><span class="scilabstring">&#0034;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<a class="scilabmacro" href="scilab://filter">filter</a> <span class="scilabstring">=</span> <span class="scilabstring">fspecial('sobel')</span><span class="scilabdefault">;</span>
<span class="scilabid">imf</span> <span class="scilaboperator">=</span> <span class="scilabid">imfilter</span><span class="scilabopenclose">(</span><span class="scilabid">im</span><span class="scilabdefault">,</span> <a class="scilabmacro" href="scilab://filter">filter</a><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">imshow</span><span class="scilabopenclose">(</span><span class="scilabid">imf</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span></pre></td><td valign="top"><a href="scilab://scilab.execexample/"><img src="ScilabExecute.png" border="0"/></a></td><td valign="top"><a href="scilab://scilab.editexample/"><img src="ScilabEdit.png" border="0"/></a></td><td></td></tr></table></div></div>

<div class="refsection"><h3 class="title">See also</h3>
   <ul class="itemizedlist"><li class="member"><a href="imfilter.html" class="link">imfilter</a></li>
   <li class="member"><a href="filter2.html" class="link">filter2</a></li></ul></div>

<div class="refsection"><h3 class="title">Authors</h3>
   <ul class="itemizedlist"><li class="member">Shiqi Yu</li>
   <li class="member">Tan Chin Luh</li></ul></div>
    <br />

    <div class="manualnavbar">
    <table width="100%">
    <tr><td colspan="3" class="next"><a href="http://bugzilla.scilab.org/enter_bug.cgi?product=Scilab%20software&component=Documentation%20pages" class="ulink">Report an issue</a></td></tr>
<tr>
      <td width="30%">
    	<span class="previous"><a href="filter2.html">&lt;&lt; filter2</a></span>

      </td>
      <td width="40%" class="center">
      	<span class="top"><a href="section_3ba7058e738fa302f12702588c6eea04.html">Image Linear Filtering</a></span>

      </td>
      <td width="30%" class="next">
      	<span class="next"><a href="imfilter.html">imfilter &gt;&gt;</a></span>

      </td>
    </tr></table>
      <hr />
    </div>
  </body>
</html>
